#pragma once
#include "olcPixelGameEngine.h"
class Polymorphism;

struct Object{
	olc::vf2d pos;
	float dir;
	olc::vf2d spd;
	olc::Renderable&img;
	bool friendly=false; //If true, this is a player unit.
	const float FRICTION = 100.f;
	olc::Pixel col;
	bool dead=false;
	float radius=8;
	Object(olc::vf2d pos,float dir,olc::vf2d spd,olc::Renderable&img,bool friendly);
	virtual void Update(Polymorphism*pge,float fElapsedTime)=0;
	virtual void Collision(Object*collidedObj)=0;
	void InternalUpdate(Polymorphism*pge,float fElapsedTime);
	void Draw(Polymorphism*pge,float fElapsedTime);
};