#include "Player.h"

Player::Player(olc::vf2d pos,float dir,olc::vf2d spd,olc::Renderable&img)
	:Object(pos,dir,spd,img,true){
	col=olc::BLUE;
}

void Player::Update(Polymorphism*pge,float fElapsedTime){
	if(pge->GetKey(olc::RIGHT).bHeld){
		spd.x=32;
	}
	if(pge->GetKey(olc::UP).bHeld){
		spd.y=-32;
	}
	if(pge->GetKey(olc::DOWN).bHeld){
		spd.y=32;
	}
	if(pge->GetKey(olc::LEFT).bHeld){
		spd.x=-32;
	}
};

void Player::Collision(Object*collidedObj){
	if(!collidedObj->friendly){
		collidedObj->dead=true;
	}
}